/* Hintergrund-Kommandointerpreter fr Kommunikation ber UART */

#include "StdTypes.h"
#include "STM32F103all.h"
#include "conv.h"
#include "events.h"
#include "startup.h"
#include "gio.h"
#include "cmd.h"

char   Kommandozeile[80];
char*  Cpt;
char*  von;
char*  bis;


void ErrorStatus(word wo)
{ CRLF_Out (wo);
  String_Out(Manifest, wo);
  CRLF_Out (wo);
  if (!Errors) return;

  String_Out("Restart nach ", wo);
  if (Errors & (1<<0))  String_Out("Warmstart ", wo);
  if (Errors & (1<<1))  String_Out("reserved. ", wo);
  if (Errors & (1<<2))  String_Out("HardFault ", wo);
  if (Errors & (1<<3))  String_Out("MemMgrErr ", wo);
  if (Errors & (1<<4))  String_Out("BusFault ", wo);
  if (Errors & (1<<5))  String_Out("UsageFault ", wo);
  if (Errors & (1<<6))  String_Out("wrong SVC ", wo);
  if (Errors & (1<<7))  String_Out("DebugMoni ", wo);
  if (Errors & (1<<8))  String_Out("PendSV ", wo);
  if (Errors & (1<<9))  String_Out("SysTick ", wo);
  if (Errors & (1<<10)) String_Out("NMI ", wo);
  if (Errors & (1<<11)) String_Out("WeakINT ", wo);
  if (Errors > 0xFFF) HexL_Out(Errors, wo);
  CRLF_Out (wo);
}


/* Display Memory */

void DoDisplay (word wo)
{ char* ivon;
  char* ibis;
  char* von2;
  dword L;
  word  i;
  char  c;

  L = 255;
  if (*Cpt)
  { { von = (char*) Hex_In(&Cpt);
      L = Hex_In(&Cpt);
      if (!L) L = 255;
      bis = von + L;
    }
  }

  ivon = (char*) von;
  ibis = (char*) bis;

  while((long) ibis >= (long) ivon)
  {  CRLF_Out(wo);
     HexL_Out((long) ivon, wo);
     von2 = ivon;
     Char_Out(':', wo);
     i = 16;
     while(i)
     { --i;
       Char_Out(' ', wo);
       HexB_Out(*ivon++, wo);
     }
     Char_Out(' ', wo);
     i = 16;
     while(i)
     { --i;
       c = *von2++;
       if ((c<' ')||(c>126)) c = ' ';
       Char_Out(c, wo);
     }
  }
  von = (char*) ivon;
  bis = (char*) ivon + L;
  CRLF_Out(wo);
}


/* Gertestatus ausgeben */
void DoStatus(word wo)
{ String_Out("Gertestatus ", wo);
  ErrorStatus(wo);
}


void DoCommand (char* Pzeile, word wo)
{ char  c;

  Cpt = Pzeile;


  if (match("D",&Cpt))     { DoDisplay(wo); return;}
  if (match("G?",&Cpt))    { StdIO = wo; DoStatus(wo);  return;}
  
  /* hier ist Platz fr weitere Kommandos */


  
  if (!*Cpt) return;
  String_Out("wat? ", wo);
  while (*Cpt)
  { c = *Cpt;
    if (c < ' ')
    { Char_Out('^',wo);
      c = c + 0x40;
    }
    Char_Out(c, wo);
    ++Cpt;
  }
  CRLF_Out(wo);
}




/*************************************************************************/

int kzi;

void InitCmd (word wo)
{  long L;

   L = sizeof(Kommandozeile);
   while (L) Kommandozeile[--L] = 0;
   kzi = L;
   Char_Out('>', wo);
}

  /* Kommandozeile hereinholen */
void Talk (word wo)
{ char c;

  if (RxAvail(wo))
  { c =  GetChar(wo);
    StdIO = wo;
    if (c==10) return;
    if (c==13)
    { CRLF_Out(wo);
      DoCommand (Kommandozeile, wo);
      InitCmd(wo);
    }
    else
    { if (kzi>=(sizeof(Kommandozeile)-1)) return;
      if (c==8)
      { Char_Out(8, wo);
        Char_Out(' ', wo);
        Char_Out(8, wo);
        if (kzi) --kzi;
        Kommandozeile[kzi]=0;
      }
      else
      { if (c<' ')
        { Char_Out('^', wo);
          Char_Out(c+0x40, wo);
          Kommandozeile[kzi++] = c;
          Kommandozeile[kzi] = 0;
	  return;
        }
        Char_Out(c, wo);
        Kommandozeile[kzi++] = c;
        Kommandozeile[kzi] = 0;
      }
    }
  }
}


  /* ende */
