;****** Startup-File fr STM32F103C8T6 ******
;
; 1. Speicherbereiche:
; interner ROM:          0h .. 0000_FFFFh    (64 KB)
; interner RAM:  2000_0000h .. 2000_4FFFh    (20 KB)

                EXPORT  Errors
                EXPORT  ErrAddr
                EXPORT  Manifest
                EXPORT  Kaltstart
                EXPORT  Ticks
                EXPORT  StartOfRam
                EXPORT  EndOfRam

; hier die allerntigsten Speicherbereiche fr den Monitor-Betrieb
Top_Ram         EQU     0x20005000      ; der interne RAM geht von 20000000 bis 20004FFFH
Errors          EQU     Top_Ram - 4     ; Bitfeld zum Merken von Fehlern etc. und zugleich..
ErrAddr         EQU     Errors  - 4     ; Adresse zu Errors
Ticks           EQU     ErrAddr - 4     ; Systick: Systemzeit in Millisekunden
__initial_sp    EQU     Ticks   - 4

StartOfRam      EQU     0x20000000
EndOfRam        EQU     __initial_sp - 1024

;********************************************************************

                PRESERVE8
                THUMB
                AREA    RESET, CODE, READONLY

;********************* Vektortafel und Kaltstart ***********************
; Vector Table Mapped to Address 0 at Reset

                DCD     __initial_sp               ; Top of Stack
                DCD     Kaltstart                  ; Reset Handler
                DCD     NMI_Handler                ; NMI Handler
                DCD     HardFault_Handler          ; Hard Fault Handler
                DCD     MemoryManagement_Handler   ; MPU Fault Handler
                DCD     BusFault_Handler           ; Bus Fault Handler
                DCD     UsageFault_Handler         ; Usage Fault Handler
                DCD     0                          ; Reserved
                DCD     0                          ; Reserved
                DCD     0                          ; Reserved
                DCD     0                          ; Reserved
                DCD     SVC_Handler                ; SVCall Handler
                DCD     DebugMonitor_Handler       ; Debug Monitor Handler
                DCD     0                          ; Reserved
                DCD     PendSV_Handler             ; PendSV Handler
                DCD     SysTick_Handler            ; SysTick Handler

; External Interrupts
                DCD     WWDG_IRQHandler            ;  0  Window Watchdog
                DCD     PVD_IRQHandler             ;  1  PVD through EXTI Line detect
                DCD     TAMPER_IRQHandler          ;  2  Tamper
                DCD     RTC_IRQHandler             ;  3  RTC
                DCD     FLASH_IRQHandler           ;  4  Flash
                DCD     RCC_IRQHandler             ;  5  RCC
                DCD     EXTI0_IRQHandler           ;  6  EXTI Line 0
                DCD     EXTI1_IRQHandler           ;  7  EXTI Line 1
                DCD     EXTI2_IRQHandler           ;  8  EXTI Line 2
                DCD     EXTI3_IRQHandler           ;  9  EXTI Line 3
                DCD     EXTI4_IRQHandler           ; 10  EXTI Line 4
                DCD     DMA1_Channel1_IRQHandler   ; 11  DMA1 Channel 1
                DCD     DMA1_Channel2_IRQHandler   ; 12  DMA1 Channel 2
                DCD     DMA1_Channel3_IRQHandler   ; 13  DMA1 Channel 3
                DCD     DMA1_Channel4_IRQHandler   ; 14  DMA1 Channel 4
                DCD     DMA1_Channel5_IRQHandler   ; 15  DMA1 Channel 5
                DCD     DMA1_Channel6_IRQHandler   ; 16  DMA1 Channel 6
                DCD     DMA1_Channel7_IRQHandler   ; 17  DMA1 Channel 7
                DCD     ADC1_2_IRQHandler          ; 18  ADC1 & ADC2
                DCD     USB_HP_CAN1_TX_IRQHandler  ; 19  USB High Priority or CAN1 TX
                DCD     USB_LP_CAN1_RX0_IRQHandler ; 20  USB Low  Priority or CAN1 RX0
                DCD     CAN1_RX1_IRQHandler        ; 21  CAN1 RX1
                DCD     CAN1_SCE_IRQHandler        ; 22  CAN1 SCE
                DCD     EXTI9_5_IRQHandler         ; 23  EXTI Line 9..5
                DCD     TIM1_BRK_IRQHandler        ; 24  TIM1 Break
                DCD     TIM1_UP_IRQHandler         ; 25  TIM1 Update
                DCD     TIM1_TRG_COM_IRQHandler    ; 26  TIM1 Trigger and Commutation
                DCD     TIM1_CC_IRQHandler         ; 27  TIM1 Capture Compare
                DCD     TIM2_IRQHandler            ; 28  TIM2
                DCD     TIM3_IRQHandler            ; 29  TIM3
                DCD     TIM4_IRQHandler            ; 30  TIM4
                DCD     I2C1_EV_IRQHandler         ; 31  I2C1 Event
                DCD     I2C1_ER_IRQHandler         ; 32  I2C1 Error
                DCD     I2C2_EV_IRQHandler         ; 33  I2C2 Event
                DCD     I2C2_ER_IRQHandler         ; 34  I2C2 Error
                DCD     SPI1_IRQHandler            ; 35  SPI1
                DCD     SPI2_IRQHandler            ; 36  SPI2
                DCD     USART1_IRQHandler          ; 37  USART1
                DCD     USART2_IRQHandler          ; 38  USART2
                DCD     USART3_IRQHandler          ; 39  USART3
                DCD     EXTI15_10_IRQHandler       ; 40  EXTI Line 15..10
                DCD     RTCAlarm_IRQHandler        ; 41  RTC Alarm through EXTI Line
                DCD     USBWakeUp_IRQHandler       ; 42  USB Wakeup from suspend
                DCD     TIM8_BRK_IRQHandler        ; 43  TIM8 Break
                DCD     TIM8_UP_IRQHandler         ; 44  TIM8 Update
                DCD     TIM8_TRG_COM_IRQHandler    ; 45  TIM8 Trigger and Commutation
                DCD     TIM8_CC_IRQHandler         ; 46  TIM8 Capture Compare
                DCD     ADC3_IRQHandler            ; 47  ADC3
                DCD     FSMC_IRQHandler            ; 48  FSMC
                DCD     SDIO_IRQHandler            ; 49  SDIO
                DCD     TIM5_IRQHandler            ; 50  TIM5
                DCD     SPI3_IRQHandler            ; 51  SPI3
                DCD     UART4_IRQHandler           ; 52  UART4
                DCD     UART5_IRQHandler           ; 53  UART5
                DCD     TIM6_IRQHandler            ; 54  TIM6
                DCD     TIM7_IRQHandler            ; 55  TIM7
                DCD     DMA2_Channel1_IRQHandler   ; 56  DMA2 Channel1
                DCD     DMA2_Channel2_IRQHandler   ; 57  DMA2 Channel2
                DCD     DMA2_Channel3_IRQHandler   ; 58  DMA2 Channel3
                DCD     DMA2_Channel4_5_IRQHandler ; 59  DMA2 Channel4 & Channel5

;
Manifest        DCB    "STM32F103C8T6 (Cortex M3)\r\n",0
                ALIGN

; Kaltstart: CPU hat SP bereits von Adresse 0 geladen
; wir exportieren __main, um dem Laden eines ganzen Rattenschwanzes
; von unbenutzten Bibliotheksfunktionen vorzubeugen.

Kaltstart       PROC
                IMPORT  main
                IMPORT  sysconfig
                EXPORT  __main

__main          LDR     R0, =Errors
                LDR     R1, =0
                STR     R1, [R0]               ;  Fehlerbits lschen
                B       MerkeFehler

; Warmstart: wird nicht exportiert, Stack ist in Ordnung da geordneter Return gewesen.
Warmstart       LDR     R1, =1
                B       MerkeFehler

; Wiederanlauf nach irgendwelchen Ausnahmen. Stack ist ungewiss.
; R1 enthlt einen Code, der auf die Ursache hinweist

Restart         LDR     R0, =__initial_sp
                MOV     SP,R0                ; Stack neu aufsetzen

; etwaige Fehlercodes in Errors merken.
MerkeFehler     LDR     R0, =Errors
                LDR     R2,[R0]
                ORRS    R2,R1
                STR     R2,[R0]

; hier bei M4F --> FPU einschalten
;                LDR.W   R0, =0xE000ED88     ; CPACR is located at address 0xE000ED88
;                LDR     R1, [R0]            ; Read CPACR
;                ORR     R1, R1, #(0xF<<20)  ; Set bits 20-23 to enable CP10 and CP11 coprocessors
;                STR     R1, [R0]            ; Write back the modified value to the CPACR

                LDR     R0, =sysconfig       ; allererste System-Konfiguration
                BLX     R0

                CPSIE   i                    ; Interrupts ein
                LDR     R0, =main
                BLX     R0
                B       Warmstart
                ENDP


;-------------- Exception Handlers --------------------------------------

NMI_Handler     PROC
                EXPORT  NMI_Handler                [WEAK]
                LDR     R1, =1024      ; war NMI
                B       Restart
                ENDP

HardFault_Handler  PROC
                EXPORT  HardFault_Handler [WEAK]
                LDR    R0, [R13, #24]        ; Get previous PC
                LDRH   R1, [R0]              ; Get instruction
                LDR    R2, =0xBEAB           ; The special BKPT instruction
                CMP    R1, R2                ; Test if the instruction at previous PC is BKPT
                BNE    HardFault_Restart     ; Not BKPT

                ADDS   R0, #4                ; Skip BKPT and next line
                STR    R0, [R13, #24]        ; Save previous PC
                BX     LR

HardFault_Restart
                LDR     R1, =4               ; war Hardfault
                B       Restart
                ENDP

MemoryManagement_Handler PROC
                EXPORT  MemoryManagement_Handler  [WEAK]
                LDR     R1, =8               ; war MM
                B       Restart
                ENDP

BusFault_Handler  PROC
                EXPORT  BusFault_Handler  [WEAK]
                LDR     R1, =16               ; war Zugriff
                B       Restart
                ENDP

UsageFault_Handler PROC
                EXPORT  UsageFault_Handler       [WEAK]
                LDR     R1, =32               ; war Zugriff
                B       Restart
                ENDP

SVC_Handler     PROC
                EXPORT  SVC_Handler       [WEAK]
                LDR     R1, =64               ; war SVC
                B       Restart
                ENDP

DebugMonitor_Handler PROC
                EXPORT  DebugMonitor_Handler  [WEAK]
                LDR     R1, =128               ; war SVC, ist hier reserviert
                B       Restart
                ENDP

PendSV_Handler  PROC
                EXPORT  PendSV_Handler    [WEAK]
                LDR     R1, =256              ; war PendSVC
                B       Restart
                ENDP

SysTick_Handler PROC
                EXPORT  SysTick_Handler   [WEAK]
                LDR     R1, =512              ; war SysTick
                B       Restart
                ENDP

Default_Handler PROC
                LDR     R1, =2      ; RAISE, war reserved
                B       Restart		

                EXPORT  WWDG_IRQHandler            [WEAK]
                EXPORT  PVD_IRQHandler             [WEAK]
                EXPORT  TAMPER_IRQHandler          [WEAK]
                EXPORT  RTC_IRQHandler             [WEAK]
                EXPORT  FLASH_IRQHandler           [WEAK]
                EXPORT  RCC_IRQHandler             [WEAK]
                EXPORT  EXTI0_IRQHandler           [WEAK]
                EXPORT  EXTI1_IRQHandler           [WEAK]
                EXPORT  EXTI2_IRQHandler           [WEAK]
                EXPORT  EXTI3_IRQHandler           [WEAK]
                EXPORT  EXTI4_IRQHandler           [WEAK]
                EXPORT  DMA1_Channel1_IRQHandler   [WEAK]
                EXPORT  DMA1_Channel2_IRQHandler   [WEAK]
                EXPORT  DMA1_Channel3_IRQHandler   [WEAK]
                EXPORT  DMA1_Channel4_IRQHandler   [WEAK]
                EXPORT  DMA1_Channel5_IRQHandler   [WEAK]
                EXPORT  DMA1_Channel6_IRQHandler   [WEAK]
                EXPORT  DMA1_Channel7_IRQHandler   [WEAK]
                EXPORT  ADC1_2_IRQHandler          [WEAK]
                EXPORT  USB_HP_CAN1_TX_IRQHandler  [WEAK]
                EXPORT  USB_LP_CAN1_RX0_IRQHandler [WEAK]
                EXPORT  CAN1_RX1_IRQHandler        [WEAK]
                EXPORT  CAN1_SCE_IRQHandler        [WEAK]
                EXPORT  EXTI9_5_IRQHandler         [WEAK]
                EXPORT  TIM1_BRK_IRQHandler        [WEAK]
                EXPORT  TIM1_UP_IRQHandler         [WEAK]
                EXPORT  TIM1_TRG_COM_IRQHandler    [WEAK]
                EXPORT  TIM1_CC_IRQHandler         [WEAK]
                EXPORT  TIM2_IRQHandler            [WEAK]
                EXPORT  TIM3_IRQHandler            [WEAK]
                EXPORT  TIM4_IRQHandler            [WEAK]
                EXPORT  I2C1_EV_IRQHandler         [WEAK]
                EXPORT  I2C1_ER_IRQHandler         [WEAK]
                EXPORT  I2C2_EV_IRQHandler         [WEAK]
                EXPORT  I2C2_ER_IRQHandler         [WEAK]
                EXPORT  SPI1_IRQHandler            [WEAK]
                EXPORT  SPI2_IRQHandler            [WEAK]
                EXPORT  USART1_IRQHandler          [WEAK]
                EXPORT  USART2_IRQHandler          [WEAK]
                EXPORT  USART3_IRQHandler          [WEAK]
                EXPORT  EXTI15_10_IRQHandler       [WEAK]
                EXPORT  RTCAlarm_IRQHandler        [WEAK]
                EXPORT  USBWakeUp_IRQHandler       [WEAK]
                EXPORT  TIM8_BRK_IRQHandler        [WEAK]
                EXPORT  TIM8_UP_IRQHandler         [WEAK]
                EXPORT  TIM8_TRG_COM_IRQHandler    [WEAK]
                EXPORT  TIM8_CC_IRQHandler         [WEAK]
                EXPORT  ADC3_IRQHandler            [WEAK]
                EXPORT  FSMC_IRQHandler            [WEAK]
                EXPORT  SDIO_IRQHandler            [WEAK]
                EXPORT  TIM5_IRQHandler            [WEAK]
                EXPORT  SPI3_IRQHandler            [WEAK]
                EXPORT  UART4_IRQHandler           [WEAK]
                EXPORT  UART5_IRQHandler           [WEAK]
                EXPORT  TIM6_IRQHandler            [WEAK]
                EXPORT  TIM7_IRQHandler            [WEAK]
                EXPORT  DMA2_Channel1_IRQHandler   [WEAK]
                EXPORT  DMA2_Channel2_IRQHandler   [WEAK]
                EXPORT  DMA2_Channel3_IRQHandler   [WEAK]
                EXPORT  DMA2_Channel4_5_IRQHandler [WEAK]
		

WWDG_IRQHandler
PVD_IRQHandler
TAMPER_IRQHandler
RTC_IRQHandler
FLASH_IRQHandler
RCC_IRQHandler
EXTI0_IRQHandler
EXTI1_IRQHandler
EXTI2_IRQHandler
EXTI3_IRQHandler
EXTI4_IRQHandler
DMA1_Channel1_IRQHandler
DMA1_Channel2_IRQHandler
DMA1_Channel3_IRQHandler
DMA1_Channel4_IRQHandler
DMA1_Channel5_IRQHandler
DMA1_Channel6_IRQHandler
DMA1_Channel7_IRQHandler
ADC1_2_IRQHandler
USB_HP_CAN1_TX_IRQHandler
USB_LP_CAN1_RX0_IRQHandler
CAN1_RX1_IRQHandler
CAN1_SCE_IRQHandler
EXTI9_5_IRQHandler
TIM1_BRK_IRQHandler
TIM1_UP_IRQHandler
TIM1_TRG_COM_IRQHandler
TIM1_CC_IRQHandler
TIM2_IRQHandler
TIM3_IRQHandler
TIM4_IRQHandler
I2C1_EV_IRQHandler
I2C1_ER_IRQHandler
I2C2_EV_IRQHandler
I2C2_ER_IRQHandler
SPI1_IRQHandler
SPI2_IRQHandler
USART1_IRQHandler
USART2_IRQHandler
USART3_IRQHandler
EXTI15_10_IRQHandler
RTCAlarm_IRQHandler
USBWakeUp_IRQHandler
TIM8_BRK_IRQHandler
TIM8_UP_IRQHandler
TIM8_TRG_COM_IRQHandler
TIM8_CC_IRQHandler
ADC3_IRQHandler
FSMC_IRQHandler
SDIO_IRQHandler
TIM5_IRQHandler
SPI3_IRQHandler
UART4_IRQHandler
UART5_IRQHandler
TIM6_IRQHandler
TIM7_IRQHandler
DMA2_Channel1_IRQHandler
DMA2_Channel2_IRQHandler
DMA2_Channel3_IRQHandler
DMA2_Channel4_5_IRQHandler

                LDR     R1, =2048                ; war WEAK Int
                B       Restart
                ENDP

                ALIGN
		LTORG
                END

